(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('qrious')) :
    typeof define === 'function' && define.amd ? define(['exports', 'qrious'], factory) :
    (global = global || self, factory(global.VueQrious = {}, global.QRious));
}(this, (function (exports, QRious) { 'use strict';

    QRious = QRious && QRious.hasOwnProperty('default') ? QRious['default'] : QRious;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    var LEVELS = ['L', 'M', 'Q', 'H'];
    var index = {
        props: {
            value: {
                type: String,
                required: true,
            },
            background: String,
            backgroundAlpha: Number,
            foreground: String,
            foregroundAlpha: Number,
            level: {
                type: String,
                validator: function (level) { return LEVELS.includes(level); },
            },
            mime: String,
            padding: Number,
            size: Number,
        },
        data: function () {
            var qrious = new QRious(this.$props);
            return {
                qrious: qrious,
                dataUrl: qrious.toDataURL(this.mime),
            };
        },
        watch: {
            $props: {
                deep: true,
                handler: function () {
                    this.qrious.set(this.$props);
                    this.dataUrl = this.qrious.toDataURL(this.mime);
                },
            },
        },
        render: function () {
            return this.$createElement('img', {
                domProps: __assign(__assign({}, this.$attrs), { src: this.dataUrl }),
            });
        },
    };

    exports.LEVELS = LEVELS;
    exports.default = index;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
